#include <algorithm>
#include <cstdio>
#include <cstring>
using namespace std;

struct node {
    long long value;
    long long bestMax;  // best max so far -- resets after propagation.
    long long curSum;  // Sum up -- current value.
};

int n, k;
node v[1 << 19];

void notify_best(int nd, long long bm) {
    v[nd].bestMax = max(v[nd].bestMax, bm + v[nd].value);
}

void push_down(int nd) {
    if (nd < (1 << 18)) {
        // not leaf.
        notify_best(nd * 2, v[nd].bestMax);
        notify_best(nd * 2 + 1, v[nd].bestMax);
        v[nd].bestMax = -(1LL << 50);
    }
}

void add(int nd, int nl, int nr, int le, int ri, long long de, long long csum) {
    if (nl > ri || le > nr) {
        return;
    }
    push_down(nd);
    if (le <= nl && nr <= ri) {
        v[nd].value += de;
        v[nd].curSum = csum + v[nd].value;
        v[nd].bestMax = max(v[nd].bestMax, csum + v[nd].value);
        return;
    }

    add(nd * 2, nl, (nl + nr) / 2, le, ri, de, csum + v[nd].value);
    add(nd * 2 + 1, (nl + nr) / 2 + 1, nr, le, ri, de, csum + v[nd].value);
}

void change_wall(int le, int ri, int de) {
    add(1, 1, (1 << 18), le, ri, de, 0);
}

bool firstGet = false;

long long get_wall_h(int p, int r) {
    if (!firstGet) {
        firstGet = true;
        for (int i = 1; i < (1 << 18); ++i) {
            push_down(i);
        }
    }
    return v[p + (1 << 18) - 1].bestMax;
}

void init(int n) {
    memset(v, 0, sizeof(v));
}
